package edi.upvehu.gbg.tap.demos;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.Charset;


public class Codificaciones {
    private static final String LATIN1="latin1";
    private static final String UTF8="utf8";

    public static void main(String[] args) throws IOException {

        //ver codificaciones disponibles
        int n=0;
        System.out.println("Codificaciones disponibles:");
        for (String s:Charset.availableCharsets().keySet()) System.out.print(s+(++n%8==0?"\n":", "));
        System.out.println();
        //ver codificación por defecto
        System.out.println("Codificación por defecto: "+Charset.defaultCharset());
        //Obtener un Charset por su nombre y ver sus alias
        System.out.println("Alias de "+LATIN1+Charset.forName(LATIN1).aliases());
        //Comprobar si existe un charset con un nombre dado
        System.out.println("¿is cp819 supported? "+Charset.isSupported("cp819"));

        //Analizar un fichero interpretandolo como latin1 o utf8
        mostrarFichero("tmp.txt",LATIN1);
        mostrarFichero("tmp.txt",UTF8);
    }

    //RUTINA PARA ANALIZAR UN FICHERO COMO TEXTO CODIFICADO CON UN DETERMINADO CHARSET
    static void mostrarFichero(String filename,String charsetName) throws IOException{
        //Try con dos recursos: Un reader con la cidificación dada y un inputStream
        try (var miReader=new InputStreamReader(new FileInputStream(filename),charsetName);
             var miInputStream=new FileInputStream(filename); ) {
            //Leemos de ambos recursos sobre arrays de 500 elementos
            char[] charBuffer=new char[500];int nChars=miReader.read(charBuffer);
            byte[] byteBuffer=new byte[500];int nBytes=miInputStream.read(byteBuffer);

            //Informamos del número de byte sy caracteres leídos
            System.out.format("------------\n%s (%d bytes) interpretado como %s (%d caracteres)\n------------\n",
                    filename, nBytes, charsetName, nChars);

            //Mostramos los caracteres, los códigos de los caracteres, y los bytes del fichero
            for (int i=0;i<nChars;i++) System.out.format("%c",charBuffer[i]); System.out.println();
            for (int i=0;i<nChars;i++) System.out.format("/%d",(int)charBuffer[i]); System.out.println();
            for (int i=0;i<nBytes;i++) System.out.format("/%d",0xFF&byteBuffer[i]); System.out.println();
        }

    }













}
