package edi.upvehu.gbg.tap.demos;

import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

public class Listas {
    private static final int NUM_ADDS=50_000_000;
    private static final int NUM_REMOVES=500;
    private static final int REMOVE_INDEX=100; //comparar con 100 y con 1000;

    public static void main(String[] args) throws IOException {

        //Puebas con una lista concreta soportada por un array
        ejecutaPrueba(new ArrayList<>());

        //Pedimos recogida de basuras al haber liberado una estructura importante
        System.gc();

        //Puebas con una lista concreta soportada por una estructura ligada
        ejecutaPrueba(new LinkedList<>());

    }

    static void ejecutaPrueba(List<Double> miLista) {
        long ti,tf;

        //Se añaden NUM_ADDS dobles aleatorios y se muestra el tiempo
        ti=System.currentTimeMillis();
        for (int i=0;i<NUM_ADDS;i++) miLista.add(Math.random());
        tf = System.currentTimeMillis();
        System.out.println(tf - ti);

        ti=System.currentTimeMillis();
        for (int i=0;i<NUM_REMOVES;i++) miLista.remove(REMOVE_INDEX);
        tf=System.currentTimeMillis();
        System.out.println(tf-ti);
    }
    
    
    

}
