package edi.upvehu.gbg.tap.demos;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

public class ZipDemo {

    private static int numFiles=0;
    private static int numLines=0;

    public static void main(String[] args) throws IOException {
        long ti,tf;

        //Procesamos todos los ficheros de un directorio.
        ti=System.currentTimeMillis();
        File dir = new File("datos");
        for (File f : dir.listFiles()) procesa(new FileInputStream(f)); 
        tf=System.currentTimeMillis();
        System.out.format("Procesadas %d lineas de %d ficheros en %f segundos\n",numLines,numFiles,(tf-ti)/1000.0);

        //Procesamos todos los ficheros de un zip.
        numFiles=numLines=0;
        ti=System.currentTimeMillis();
        ZipFile zf = new ZipFile("datos.zip");
        Enumeration<ZipEntry> ze = (Enumeration<ZipEntry>) zf.entries();
        while (ze.hasMoreElements()) procesa(zf.getInputStream(ze.nextElement()));
        tf=System.currentTimeMillis();
        System.out.format("Procesadas %d lineas de %d ficheros en %f segundos\n",numLines,numFiles,(tf-ti)/1000.0);
    }

    //Rutina de procesamiento. Se limita a incrementar el contador lineas y el de número de ficheros
    private static void procesa(InputStream is) throws IOException {
        BufferedReader br=new BufferedReader(new InputStreamReader(is));
        while ((br.readLine())!=null) numLines++;
        numFiles++;
        br.close();
    }

}